/*
         +------------------------+
         | Traversal              |
         +------------------------+
         | boolean isEmpty()      |
         | ISame getFirst()       |
         | Traversal getRest()    |
         +------------------------+
                    / \
                    ---
                     |
                     |
             +----------------------------+                
             |  AList                     |                
             +----------------------------+                
	         | boolean same(Obj that)     |
	         | boolean contains(Obj that) | 
             +----------------------------+                
                         |                    
                        / \                   
                        ---                   
                         |                    
           ---------------------------          
           |                         |          
    +-------------+          +---------------+  
    | MTList      |          | ConsList      |  
    +-------------+          +---------------+  
    +-------------+     +----| ISame fist    | 
                        |    | AList rest    |   
                        |    +---------------+ 
	            		v
            +--------------------------+ 
            | ISame                    |   
	        +--------------------------+
	        | boolean same(ISame that) |
	        +--------------------------+
                        |
                       / \
                       ---
                        |
                +---------------+    
                | ImageFile     |    
                +---------------+    
                | String name   |     
                | int    width  |      
                | int    height |      
                | String kind   |      
                +---------------+    

 */  

//to represent a list of objects.
interface AList extends ISame{
  
  // is this object the same as that object?
  boolean same(ISame that);

  // does this list contan the given object?
  boolean contains(ISame that);
}      


